/*
 * GuiEdificar.java
 *
 * Created on 8 de enero de 2008, 20:54
 */

package interfaz;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Vector;
import javax.imageio.ImageIO;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import uhupoly.Juego;
import uhupoly.Jugador;
import uhupoly.Propiedad;
import uhupoly.Solar;

/**
 *
 * @author  Pandre
 */
public class GuiEdificar extends javax.swing.JDialog {
    
    Juego juego;
    Vector vectorPropiedades = new Vector();
    Solar seleccionado = null;
    Jugador jugador = null;
    
    /** Creates new form GuiEdificar */
    public GuiEdificar(java.awt.Frame parent, boolean modal, Juego juego) {
        super(parent, modal);
        
        this.juego = juego;
        this.jugador = juego.getJugadores().get(juego.getTurno());
        
        initComponents();
        
        jListPropiedades.setCellRenderer(new ComplexCellRenderer());
        
        rellenaPropiedades();
        
        
    }
    
    private void rellenaPropiedades() {
        
        Jugador jugador = juego.getJugadores().get(juego.getTurno());
        Solar solar = null;
        Propiedad propiedad = null;
        
        vectorPropiedades.clear();
        jListPropiedades.removeAll();
                
        // recorremos todas las propiedades del jugador
        for (int i = 0; i < jugador.getPropiedades().size(); i++)
        {
            propiedad = jugador.getPropiedades().get(i);
            if (propiedad instanceof Solar)
            {
                solar = ((Solar)propiedad);
            
                // comprobar si tambin posee los asociados
                boolean estanTodos = true;
                for (int j = 0; j < solar.getAsociados().size(); j++)
                {
                    if (!jugador.getPropiedades().contains(solar.getAsociados().get(j)))
                        estanTodos = false;
                }
                
                if (estanTodos)
                {
                
                    // obtenemos el n maximo y minimo de casas
                    int maxNumCasas = 0;
                    int minNumCasas = 0;
                    if (solar.getNumCasas() > maxNumCasas)
                            maxNumCasas = solar.getNumCasas();
                    for (int j = 0; j < solar.getAsociados().size(); j++)
                        if (solar.getAsociados().get(j).getNumCasas() > maxNumCasas)
                            maxNumCasas = solar.getAsociados().get(j).getNumCasas();
                    minNumCasas = maxNumCasas;
                    if (solar.getNumCasas() < minNumCasas)
                            minNumCasas = solar.getNumCasas();
                    for (int j = 0; j < solar.getAsociados().size(); j++)
                        if (solar.getAsociados().get(j).getNumCasas() < minNumCasas)
                            minNumCasas = solar.getAsociados().get(j).getNumCasas();
                    
                    // si son iguales los maximos y minimos, mostramos todos los solares del grupo
                    if ((minNumCasas == maxNumCasas) && (!solar.getTieneHotel()) && (!solar.getHipotecada()))
                    {
                        vectorPropiedades.add(solar);
                    }
                    // si es menor el minimo, solo mostrar los solares del minimo
                    if ((minNumCasas < maxNumCasas) && (solar.getNumCasas() == minNumCasas) && (!solar.getTieneHotel()) && (!solar.getHipotecada()))
                    {
                        vectorPropiedades.add(solar);
                    }
                
                }
                
            }
        }
        
        jListPropiedades.setListData(vectorPropiedades);
        
    }
    
    private static ImageIcon rotarImagen(int numCasilla, int grados)
    {
        // Carga la imagen
        BufferedImage imagen = null;
        try
        {
            imagen = ImageIO.read(new File("res\\casilla" + numCasilla + ".png"));
        }
        catch(IOException ioe) {}
        
        // Imagen resultante
        ImageIcon icono = new ImageIcon();
        {
            // Creamos una imagen temporal en memoria
            BufferedImage bi = new BufferedImage(90, 90, BufferedImage.TYPE_INT_ARGB);
            Graphics2D g2 = bi.createGraphics();

            // Definimos la transformacin
            double angulo = Math.toRadians(grados);
            double x = (90 - imagen.getWidth())/2;
            double y = (90 - imagen.getHeight())/2;
            AffineTransform at = AffineTransform.getTranslateInstance(x,y);
            at.rotate(angulo, imagen.getWidth()/2, imagen.getHeight()/2);
            
            // Dibujamos la imagen original con la transformacin en la temporal
            g2.drawRenderedImage(imagen, at);
            
            // Liberamos la memoria usada
            g2.dispose();
            
            // Devolvemos la imagen rotada
            icono = new ImageIcon(bi);
        }

        return icono;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jButtonCerrar = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabelImagen = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabelPrecioCasa = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabelPrecioHotel = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jLabelHay = new javax.swing.JLabel();
        jButtonConsCasa = new javax.swing.JButton();
        jButtonConsHotel = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListPropiedades = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Edificar");
        jButtonCerrar.setText("Cerrar");
        jButtonCerrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCerrarActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18));
        jLabel1.setText("EDIFICAR");

        jLabel2.setText("Edificar en:");

        jLabelImagen.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

        jLabel4.setText("Precio de cada casa:");

        jLabelPrecioCasa.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelPrecioCasa.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPrecioCasa.setText(" ");

        jLabel6.setText("Precio de un hotel:");

        jLabelPrecioHotel.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelPrecioHotel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPrecioHotel.setText(" ");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabelImagen, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(61, 61, 61))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabelPrecioCasa, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                            .addComponent(jLabelPrecioHotel, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE))
                        .addContainerGap())))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelImagen, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPrecioCasa, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPrecioHotel, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        jLabel8.setText("En la propiedad hay actualmente:");

        jLabelHay.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabelHay.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelHay.setText(" ");

        jButtonConsCasa.setText("Construir casa");
        jButtonConsCasa.setEnabled(false);
        jButtonConsCasa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonConsCasaActionPerformed(evt);
            }
        });

        jButtonConsHotel.setText("Construir hotel");
        jButtonConsHotel.setEnabled(false);
        jButtonConsHotel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonConsHotelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelHay, javax.swing.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                    .addComponent(jLabel8)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jButtonConsCasa)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonConsHotel)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelHay)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 34, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonConsCasa)
                    .addComponent(jButtonConsHotel))
                .addContainerGap())
        );

        jListPropiedades.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Art\u00edculo 1", "Art\u00edculo 2", "Art\u00edculo 3", "Art\u00edculo 4", "Art\u00edculo 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListPropiedades.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jListPropiedades.setLayoutOrientation(javax.swing.JList.VERTICAL_WRAP);
        jListPropiedades.setVisibleRowCount(3);
        jListPropiedades.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jListPropiedadesValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(jListPropiedades);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 286, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                            .addComponent(jButtonCerrar)))
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 11, Short.MAX_VALUE)
                        .addComponent(jButtonCerrar))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonConsHotelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonConsHotelActionPerformed

        seleccionado.setTieneHotel(true);
        juego.getObservador().actualizaCasilla(seleccionado);
        
        jugador.setCapital(jugador.getCapital() - seleccionado.getPrecioHotel());
        
        juego.getObservador().actualizaJugador(jugador);

        rellenaPropiedades();
        
    }//GEN-LAST:event_jButtonConsHotelActionPerformed

    private void jButtonConsCasaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonConsCasaActionPerformed

        seleccionado.setNumCasas(seleccionado.getNumCasas() + 1);
        juego.getObservador().actualizaCasilla(seleccionado);
        
        jugador.setCapital(jugador.getCapital() - seleccionado.getPrecioCasa());
        
        juego.getObservador().actualizaJugador(jugador);

        rellenaPropiedades();

        
    }//GEN-LAST:event_jButtonConsCasaActionPerformed

    private void jListPropiedadesValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jListPropiedadesValueChanged

        seleccionado = (Solar)jListPropiedades.getSelectedValue();
        if (seleccionado == null) 
        {
            jLabelPrecioCasa.setText(" ");
            jLabelPrecioHotel.setText(" ");
            jLabelHay.setText(" ");
            jButtonConsCasa.setEnabled(false);
            jButtonConsHotel.setEnabled(false);
            jLabelImagen.setIcon(null);
            return;
        }
        int angulo;
            int numCasilla = seleccionado.getIdCasilla();
            if ((numCasilla > 1) && (numCasilla < 11)) angulo = 0;
            else if ((numCasilla > 11) && (numCasilla < 21)) angulo = -90;
            else if ((numCasilla > 21) && (numCasilla < 31)) angulo = 180;
            else angulo = 90;
            if ((numCasilla == 26) || (numCasilla == 29)) angulo = 0;

        // ponemos la imagen seleccionada    
        jLabelImagen.setIcon(rotarImagen(seleccionado.getIdCasilla(), angulo));
        
        // mostramos los datos
        float precio;
        if (seleccionado.getNumCasas() < 4)
            precio = seleccionado.getPrecioCasa();
        else
            precio = seleccionado.getPrecioHotel();
        
        jLabelHay.setText(seleccionado.getNumCasas() + " casas");
        
        if (jugador.tieneEfectivo(precio))
        {
        
            jLabelPrecioCasa.setText(seleccionado.getPrecioCasa() + "");
            jLabelPrecioHotel.setText(seleccionado.getPrecioHotel() + "");

            jButtonConsCasa.setEnabled(seleccionado.getNumCasas() < 4);
            jButtonConsHotel.setEnabled(seleccionado.getNumCasas() == 4);
            
        } else
        {
            if (seleccionado.getNumCasas() < 4)
            {
                jLabelPrecioCasa.setText("No tienes dinero!");
                jLabelPrecioHotel.setText(" ");
            }
            else
            {
                jLabelPrecioCasa.setText(" ");
                jLabelPrecioHotel.setText("No tienes dinero!");
            }
        }
        
        
    }//GEN-LAST:event_jListPropiedadesValueChanged

    private void jButtonCerrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCerrarActionPerformed

        this.setVisible(false);
        dispose();
        
    }//GEN-LAST:event_jButtonCerrarActionPerformed

    
    // Declaracin de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCerrar;
    private javax.swing.JButton jButtonConsCasa;
    private javax.swing.JButton jButtonConsHotel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabelHay;
    private javax.swing.JLabel jLabelImagen;
    private javax.swing.JLabel jLabelPrecioCasa;
    private javax.swing.JLabel jLabelPrecioHotel;
    private javax.swing.JList jListPropiedades;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    // Fin de declaracin de variables//GEN-END:variables
    
    
    class ComplexCellRenderer implements ListCellRenderer {
    protected DefaultListCellRenderer defaultRenderer = new DefaultListCellRenderer();

    public Component getListCellRendererComponent(JList list, Object value, int index,
        boolean isSelected, boolean cellHasFocus) {

        JLabel renderer = (JLabel) defaultRenderer.getListCellRendererComponent(list, value, index,
            isSelected, cellHasFocus);
        
        renderer.setHorizontalAlignment(renderer.CENTER);
        renderer.setVerticalAlignment(renderer.CENTER);
        

        if (value instanceof Solar) {
            //renderer.setIcon(new javax.swing.ImageIcon("res\\casilla" + ((Solar)value).getIdCasilla() + ".png"));
            
            int angulo;
            int numCasilla = ((Solar)value).getIdCasilla();
            if ((numCasilla > 1) && (numCasilla < 11)) angulo = 0;
            else if ((numCasilla > 11) && (numCasilla < 21)) angulo = -90;
            else if ((numCasilla > 21) && (numCasilla < 31)) angulo = 180;
            else angulo = 90;
            if ((numCasilla == 26) || (numCasilla == 29)) angulo = 0;
            
            renderer.setIcon(rotarImagen(((Solar)value).getIdCasilla(), angulo));
 
            renderer.setText("");
            renderer.setPreferredSize(new Dimension(90, 92));
        } 

        return renderer;
     }
    
    
}
}
