/*
 * GuiVender.java
 *
 * Created on 10 de enero de 2008, 16:40
 */

package interfaz;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Vector;
import javax.imageio.ImageIO;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListCellRenderer;
import uhupoly.Juego;
import uhupoly.Jugador;
import uhupoly.Propiedad;
import uhupoly.Solar;

/**
 *
 * @author  Pandre
 */
public class GuiVender extends javax.swing.JDialog {
    
    Juego juego;

    Jugador jugador = null;
    Solar solar = null;
    Propiedad propiedad = null;
    Vector vectorConstrucciones = new Vector();
    Vector vectorPropiedades = new Vector();
    
    float valorVenta;
    
    /** Creates new form GuiVender */
    public GuiVender(java.awt.Frame parent, boolean modal, Juego juego) {
        super(parent, modal);
        
        this.juego = juego;
        this.jugador = juego.getJugadores().get(juego.getTurno());
        
        initComponents();
        
        jButtonVenderAJ3.setVisible(false);
        jButtonVenderAJ4.setVisible(false);
        jButtonVenderAJ5.setVisible(false);
        jButtonVenderAJ6.setVisible(false); 
        jPanelVenderA.setVisible(false);
        jLabelVenderA.setVisible(false);
        jPanelSuma.setVisible(false);
        
        int numJugadores = juego.getJugadores().size();
        switch (numJugadores) {
            case 6: {
                jButtonVenderAJ6.setVisible(true);
                jButtonVenderAJ6.setEnabled(!juego.getJugadores().get(5).getArruinado());
                jButtonVenderAJ6.setText(juego.getJugadores().get(5).getNombre());
            }
            case 5: {
                jButtonVenderAJ5.setVisible(true);
                jButtonVenderAJ5.setEnabled(!juego.getJugadores().get(4).getArruinado());
                jButtonVenderAJ5.setText(juego.getJugadores().get(4).getNombre());
            }
            case 4: {
                jButtonVenderAJ4.setVisible(true);
                jButtonVenderAJ4.setEnabled(!juego.getJugadores().get(3).getArruinado());
                jButtonVenderAJ4.setText(juego.getJugadores().get(3).getNombre());
            }
            case 3: {
                jButtonVenderAJ3.setVisible(true);
                jButtonVenderAJ3.setEnabled(!juego.getJugadores().get(2).getArruinado());
                jButtonVenderAJ3.setText(juego.getJugadores().get(2).getNombre());
            }
            default: {
                jButtonVenderAJ2.setEnabled(!juego.getJugadores().get(1).getArruinado());
                jButtonVenderAJ1.setEnabled(!juego.getJugadores().get(0).getArruinado());
                jButtonVenderAJ2.setText(juego.getJugadores().get(1).getNombre());
                jButtonVenderAJ1.setText(juego.getJugadores().get(0).getNombre());
            }
        }

        switch (jugador.getNumJugador()) {
            case 1: jButtonVenderAJ1.setEnabled(false); break;
            case 2: jButtonVenderAJ2.setEnabled(false); break;
            case 3: jButtonVenderAJ3.setEnabled(false); break;
            case 4: jButtonVenderAJ4.setEnabled(false); break;
            case 5: jButtonVenderAJ5.setEnabled(false); break;
            case 6: jButtonVenderAJ6.setEnabled(false); break;
        }
        
        
        rellenaPropiedades();
        rellenaConstrucciones();
        
        jListPropiedades.setCellRenderer(new ComplexCellRenderer());
        jListConstrucciones.setCellRenderer(new ComplexCellRenderer());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListConstrucciones = new javax.swing.JList();
        jPanel3 = new javax.swing.JPanel();
        jLabelImagenC = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabelContiene = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabelBancoOfrece = new javax.swing.JLabel();
        jButtonVenderConstruccion = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListPropiedades = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jLabelImagenP = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabelValorVenta = new javax.swing.JLabel();
        jPanelSuma = new javax.swing.JPanel();
        jButtonMas100 = new javax.swing.JButton();
        jButtonMas10 = new javax.swing.JButton();
        jButtonMenos10 = new javax.swing.JButton();
        jButtonMenos100 = new javax.swing.JButton();
        jLabelVenderA = new javax.swing.JLabel();
        jPanelVenderA = new javax.swing.JPanel();
        jButtonVenderAJ1 = new javax.swing.JButton();
        jButtonVenderAJ2 = new javax.swing.JButton();
        jButtonVenderAJ3 = new javax.swing.JButton();
        jButtonVenderAJ5 = new javax.swing.JButton();
        jButtonVenderAJ4 = new javax.swing.JButton();
        jButtonVenderAJ6 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Vender propiedades");
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18));
        jLabel1.setText("VENDER PROPIEDADES");

        jButton1.setText("Cerrar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jListConstrucciones.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Art\u00edculo 1", "Art\u00edculo 2", "Art\u00edculo 3", "Art\u00edculo 4", "Art\u00edculo 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListConstrucciones.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jListConstrucciones.setLayoutOrientation(javax.swing.JList.VERTICAL_WRAP);
        jListConstrucciones.setVisibleRowCount(3);
        jListConstrucciones.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jListConstruccionesValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(jListConstrucciones);

        jLabelImagenC.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

        jLabel6.setText("El solar contiene:");

        jLabelContiene.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelContiene.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelContiene.setText(" ");

        jLabel7.setText("El banco te ofrece:");

        jLabelBancoOfrece.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelBancoOfrece.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelBancoOfrece.setText(" ");

        jButtonVenderConstruccion.setText("Vender construccion");
        jButtonVenderConstruccion.setEnabled(false);
        jButtonVenderConstruccion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderConstruccionActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabelImagenC, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel6)
                            .addComponent(jLabelContiene, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7)
                            .addComponent(jLabelBancoOfrece, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGap(57, 57, 57)
                        .addComponent(jButtonVenderConstruccion)))
                .addContainerGap(12, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelImagenC, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelContiene, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelBancoOfrece, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(71, 71, 71)
                .addComponent(jButtonVenderConstruccion)
                .addGap(101, 101, 101))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 280, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 299, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(12, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Vender construcciones al banco", jPanel1);

        jListPropiedades.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Art\u00edculo 1", "Art\u00edculo 2", "Art\u00edculo 3", "Art\u00edculo 4", "Art\u00edculo 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListPropiedades.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jListPropiedades.setLayoutOrientation(javax.swing.JList.VERTICAL_WRAP);
        jListPropiedades.setVisibleRowCount(3);
        jListPropiedades.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jListPropiedadesValueChanged(evt);
            }
        });

        jScrollPane2.setViewportView(jListPropiedades);

        jLabelImagenP.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

        jLabel8.setText("Vender propiedad por:");

        jLabelValorVenta.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelValorVenta.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelValorVenta.setText(" ");

        jButtonMas100.setText("+100");
        jButtonMas100.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMas100ActionPerformed(evt);
            }
        });

        jButtonMas10.setText("+10");
        jButtonMas10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMas10ActionPerformed(evt);
            }
        });

        jButtonMenos10.setText("-10");
        jButtonMenos10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMenos10ActionPerformed(evt);
            }
        });

        jButtonMenos100.setText("-100");
        jButtonMenos100.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMenos100ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelSumaLayout = new javax.swing.GroupLayout(jPanelSuma);
        jPanelSuma.setLayout(jPanelSumaLayout);
        jPanelSumaLayout.setHorizontalGroup(
            jPanelSumaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelSumaLayout.createSequentialGroup()
                .addComponent(jButtonMas100)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonMas10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonMenos10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonMenos100, javax.swing.GroupLayout.DEFAULT_SIZE, 59, Short.MAX_VALUE))
        );
        jPanelSumaLayout.setVerticalGroup(
            jPanelSumaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelSumaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jButtonMas100)
                .addComponent(jButtonMenos10)
                .addComponent(jButtonMas10)
                .addComponent(jButtonMenos100))
        );

        jLabelVenderA.setText("Vender a:");

        jButtonVenderAJ1.setText("jButton2");
        jButtonVenderAJ1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderAJ1ActionPerformed(evt);
            }
        });

        jButtonVenderAJ2.setText("jButton2");
        jButtonVenderAJ2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderAJ2ActionPerformed(evt);
            }
        });

        jButtonVenderAJ3.setText("jButton2");
        jButtonVenderAJ3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderAJ3ActionPerformed(evt);
            }
        });

        jButtonVenderAJ5.setText("jButton2");
        jButtonVenderAJ5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderAJ5ActionPerformed(evt);
            }
        });

        jButtonVenderAJ4.setText("jButton2");
        jButtonVenderAJ4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderAJ4ActionPerformed(evt);
            }
        });

        jButtonVenderAJ6.setText("jButton2");
        jButtonVenderAJ6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderAJ6ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelVenderALayout = new javax.swing.GroupLayout(jPanelVenderA);
        jPanelVenderA.setLayout(jPanelVenderALayout);
        jPanelVenderALayout.setHorizontalGroup(
            jPanelVenderALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelVenderALayout.createSequentialGroup()
                .addComponent(jButtonVenderAJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonVenderAJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(jPanelVenderALayout.createSequentialGroup()
                .addComponent(jButtonVenderAJ3, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonVenderAJ4, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(jPanelVenderALayout.createSequentialGroup()
                .addComponent(jButtonVenderAJ5, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonVenderAJ6, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanelVenderALayout.setVerticalGroup(
            jPanelVenderALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelVenderALayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelVenderALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonVenderAJ1)
                    .addComponent(jButtonVenderAJ2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelVenderALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonVenderAJ3)
                    .addComponent(jButtonVenderAJ4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelVenderALayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonVenderAJ5)
                    .addComponent(jButtonVenderAJ6))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jLabelImagenP, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addGap(4, 4, 4))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabelValorVenta, javax.swing.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                        .addContainerGap())))
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jPanelSuma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jLabelVenderA)
                .addContainerGap())
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jPanelVenderA, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelImagenP, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelValorVenta, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(23, 23, 23)
                .addComponent(jPanelSuma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 29, Short.MAX_VALUE)
                .addComponent(jLabelVenderA)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelVenderA, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 280, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 299, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(12, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Vender propiedades a otros jugadores", jPanel2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 553, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(500, Short.MAX_VALUE)
                .addComponent(jButton1)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 350, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonMenos100ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMenos100ActionPerformed

        valorVenta -= 100;
        if (valorVenta < 0) valorVenta = 0;
        jLabelValorVenta.setText(valorVenta + "");
        
    }//GEN-LAST:event_jButtonMenos100ActionPerformed

    private void jButtonMenos10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMenos10ActionPerformed

        valorVenta -= 10;
        if (valorVenta < 0) valorVenta = 0;
        jLabelValorVenta.setText(valorVenta + "");
        
    }//GEN-LAST:event_jButtonMenos10ActionPerformed

    private void jButtonMas10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMas10ActionPerformed

        valorVenta += 10;
        jLabelValorVenta.setText(valorVenta + "");
        
    }//GEN-LAST:event_jButtonMas10ActionPerformed

    private void jButtonMas100ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMas100ActionPerformed

        valorVenta += 100;
        jLabelValorVenta.setText(valorVenta + "");
        
    }//GEN-LAST:event_jButtonMas100ActionPerformed

    void venderAlJugador(int numJugador) {
    
        Jugador comprador = juego.getJugadores().get(numJugador);
        
        if (!comprador.tieneEfectivo(valorVenta))
        {
            JOptionPane.showMessageDialog(null, "" + comprador.getNombre() + " no tiene suficiente dinero para pagar " + valorVenta + "!\n", comprador.getNombre() + " no puede comprar", JOptionPane.PLAIN_MESSAGE );
            return;
        }
        
        propiedad.setPropietario(comprador);
        jugador.getPropiedades().remove(propiedad);
        comprador.getPropiedades().add(propiedad);
        jugador.setCapital(jugador.getCapital() + valorVenta);
        comprador.setCapital(comprador.getCapital() - valorVenta);
        juego.getObservador().actualizaCasilla(propiedad);
        juego.getObservador().actualizaJugador(jugador);
        juego.getObservador().actualizaJugador(comprador);
        rellenaPropiedades();
        rellenaConstrucciones();
        
    }
    
    private void jButtonVenderAJ6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderAJ6ActionPerformed
        
        venderAlJugador(5);
        
    }//GEN-LAST:event_jButtonVenderAJ6ActionPerformed

    private void jButtonVenderAJ5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderAJ5ActionPerformed
        
        venderAlJugador(4);
        
    }//GEN-LAST:event_jButtonVenderAJ5ActionPerformed

    private void jButtonVenderAJ4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderAJ4ActionPerformed
        
        venderAlJugador(3);
        
    }//GEN-LAST:event_jButtonVenderAJ4ActionPerformed

    private void jButtonVenderAJ3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderAJ3ActionPerformed
        
        venderAlJugador(2);
        
    }//GEN-LAST:event_jButtonVenderAJ3ActionPerformed

    private void jButtonVenderAJ2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderAJ2ActionPerformed
        
        venderAlJugador(1);
        
    }//GEN-LAST:event_jButtonVenderAJ2ActionPerformed

    private void jButtonVenderAJ1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderAJ1ActionPerformed
        
        venderAlJugador(0);
        
    }//GEN-LAST:event_jButtonVenderAJ1ActionPerformed

    private void jButtonVenderConstruccionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVenderConstruccionActionPerformed

        if (solar.getTieneHotel())
        {
            solar.setTieneHotel(false);
            solar.setNumCasas(4);
            jugador.setCapital(jugador.getCapital() + solar.getPrecioHotel()/2);
            juego.getObservador().actualizaCasilla(solar);
            juego.getObservador().actualizaJugador(jugador);
        } else
        {
            solar.setTieneHotel(false);
            solar.setNumCasas(solar.getNumCasas() - 1);
            jugador.setCapital(jugador.getCapital() + solar.getPrecioCasa()/2);
            juego.getObservador().actualizaCasilla(solar);
            juego.getObservador().actualizaJugador(jugador);
        }
        
        rellenaPropiedades();
        rellenaConstrucciones();
        
    }//GEN-LAST:event_jButtonVenderConstruccionActionPerformed

    private void jListPropiedadesValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jListPropiedadesValueChanged
        propiedad = (Propiedad)jListPropiedades.getSelectedValue();
        if (propiedad == null) 
        {
            jLabelValorVenta.setText(" ");
            jPanelVenderA.setVisible(false);
            jLabelVenderA.setVisible(false);
            jPanelSuma.setVisible(false);
            jLabelImagenP.setIcon(null);
            return;
        }
        int angulo;
            int numCasilla = propiedad.getIdCasilla();
            if ((numCasilla > 1) && (numCasilla < 11)) angulo = 0;
            else if ((numCasilla > 11) && (numCasilla < 21)) angulo = -90;
            else if ((numCasilla > 21) && (numCasilla < 31)) angulo = 180;
            else angulo = 90;
            if ((numCasilla == 26) || (numCasilla == 29)) angulo = 0;

        // ponemos la imagen seleccionada    
        jLabelImagenP.setIcon(rotarImagen(propiedad.getIdCasilla(), angulo));
        
        jPanelVenderA.setVisible(true);
        jLabelVenderA.setVisible(true);
        jPanelSuma.setVisible(true);
        
        valorVenta = propiedad.getPrecio() * 2;
        
        jLabelValorVenta.setText(valorVenta + "");
        
    }//GEN-LAST:event_jListPropiedadesValueChanged

    private void jListConstruccionesValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jListConstruccionesValueChanged

        solar = (Solar)jListConstrucciones.getSelectedValue();
        if (solar == null) 
        {
            jLabelContiene.setText(" ");
            jLabelBancoOfrece.setText(" ");
            jLabelImagenC.setIcon(null);
            jButtonVenderConstruccion.setEnabled(false);
            return;
        }
        int angulo;
            int numCasilla = solar.getIdCasilla();
            if ((numCasilla > 1) && (numCasilla < 11)) angulo = 0;
            else if ((numCasilla > 11) && (numCasilla < 21)) angulo = -90;
            else if ((numCasilla > 21) && (numCasilla < 31)) angulo = 180;
            else angulo = 90;
            if ((numCasilla == 26) || (numCasilla == 29)) angulo = 0;

        // ponemos la imagen seleccionada    
        jLabelImagenC.setIcon(rotarImagen(solar.getIdCasilla(), angulo));
        
        // mostramos los datos
        if (solar.getTieneHotel())
            jLabelContiene.setText("un hotel");
        else if (solar.getNumCasas() == 1)
            jLabelContiene.setText(solar.getNumCasas() + " casa");
        else
            jLabelContiene.setText(solar.getNumCasas() + " casas");
        
        jLabelBancoOfrece.setText((solar.getPrecioCasa()/2) + "");

        jButtonVenderConstruccion.setEnabled(true);
        
    }//GEN-LAST:event_jListConstruccionesValueChanged

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        this.setVisible(false);
        dispose();
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    void rellenaPropiedades() {

        Jugador jugador = juego.getJugadores().get(juego.getTurno());
        Solar solar = null;
        Propiedad propiedad = null;
        
        vectorPropiedades.clear();
        jListPropiedades.removeAll();
                
        // recorremos todas las propiedades del jugador
        for (int i = 0; i < jugador.getPropiedades().size(); i++)
        {
            propiedad = jugador.getPropiedades().get(i);
            if (propiedad instanceof Solar)
            {
                solar = ((Solar)propiedad);
            
                // comprobar si tambin posee los asociados
                boolean estanTodos = true;
                for (int j = 0; j < solar.getAsociados().size(); j++)
                {
                    if (!jugador.getPropiedades().contains(solar.getAsociados().get(j)))
                        estanTodos = false;
                }
                
                if (estanTodos)
                {
                
                    // vemos si algun solar esta edificado
                    boolean algunoTieneCasa = false;
                    
                    if ((solar.getNumCasas() > 0) || (solar.getTieneHotel()))
                            algunoTieneCasa = true;
                    
                    for (int j = 0; j < solar.getAsociados().size(); j++)
                        if ((solar.getAsociados().get(j).getNumCasas() > 0) ||
                            (solar.getAsociados().get(j).getTieneHotel()))
                                algunoTieneCasa = true;
                    
                    
                    if (!algunoTieneCasa)
                    {
                        vectorPropiedades.add(solar);
                    }
                
                }
                else
                    vectorPropiedades.add(solar);
                
            } else
                vectorPropiedades.add(propiedad);
        }
        
        jListPropiedades.setListData(vectorPropiedades);
    }
    
    void rellenaConstrucciones() {
        Jugador jugador = juego.getJugadores().get(juego.getTurno());
        Solar solar = null;
        Propiedad propiedad = null;
        
        vectorConstrucciones.clear();
        jListConstrucciones.removeAll();
                
        // recorremos todas las propiedades del jugador
        for (int i = 0; i < jugador.getPropiedades().size(); i++)
        {
            propiedad = jugador.getPropiedades().get(i);
            if (propiedad instanceof Solar)
            {
                solar = ((Solar)propiedad);
            
                
                
                    // obtenemos el n maximo y minimo de casas
                    int maxNumCasas = 0;
                    int minNumCasas = 0;
                    boolean algunoTieneHotel = false;
                    
                    if (solar.getNumCasas() > maxNumCasas)
                            maxNumCasas = solar.getNumCasas();
                    
                    for (int j = 0; j < solar.getAsociados().size(); j++)
                    {
                        if (solar.getAsociados().get(j).getNumCasas() > maxNumCasas)
                            maxNumCasas = solar.getAsociados().get(j).getNumCasas();
                        if (solar.getAsociados().get(j).getTieneHotel())
                            algunoTieneHotel = true;
                    }
                    minNumCasas = maxNumCasas;
                    if (solar.getNumCasas() < minNumCasas)
                            minNumCasas = solar.getNumCasas();
                    for (int j = 0; j < solar.getAsociados().size(); j++)
                        if (solar.getAsociados().get(j).getNumCasas() < minNumCasas)
                            minNumCasas = solar.getAsociados().get(j).getNumCasas();
                    
                    // si son iguales los maximos y minimos, mostramos todos los solares del grupo
                    if (solar.getTieneHotel())
                    {
                        vectorConstrucciones.add(solar);
                    } else
                    // si es menor el minimo, solo mostrar los solares del minimo
                    if ((solar.getNumCasas() == maxNumCasas) && (!algunoTieneHotel) && (solar.getNumCasas() > 0))
                    {
                        vectorConstrucciones.add(solar);
                    }

            }
        }
        
        jListConstrucciones.setListData(vectorConstrucciones);
    }
        
    // Declaracin de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonMas10;
    private javax.swing.JButton jButtonMas100;
    private javax.swing.JButton jButtonMenos10;
    private javax.swing.JButton jButtonMenos100;
    private javax.swing.JButton jButtonVenderAJ1;
    private javax.swing.JButton jButtonVenderAJ2;
    private javax.swing.JButton jButtonVenderAJ3;
    private javax.swing.JButton jButtonVenderAJ4;
    private javax.swing.JButton jButtonVenderAJ5;
    private javax.swing.JButton jButtonVenderAJ6;
    private javax.swing.JButton jButtonVenderConstruccion;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabelBancoOfrece;
    private javax.swing.JLabel jLabelContiene;
    private javax.swing.JLabel jLabelImagenC;
    private javax.swing.JLabel jLabelImagenP;
    private javax.swing.JLabel jLabelValorVenta;
    private javax.swing.JLabel jLabelVenderA;
    private javax.swing.JList jListConstrucciones;
    private javax.swing.JList jListPropiedades;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanelSuma;
    private javax.swing.JPanel jPanelVenderA;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    // Fin de declaracin de variables//GEN-END:variables
    
    private static ImageIcon rotarImagen(int numCasilla, int grados)
    {
        // Carga la imagen
        BufferedImage imagen = null;
        try
        {
            imagen = ImageIO.read(new File("res\\casilla" + numCasilla + ".png"));
        }
        catch(IOException ioe) {}
        
        // Imagen resultante
        ImageIcon icono = new ImageIcon();
        {
            // Creamos una imagen temporal en memoria
            BufferedImage bi = new BufferedImage(90, 90, BufferedImage.TYPE_INT_ARGB);
            Graphics2D g2 = bi.createGraphics();

            // Definimos la transformacin
            double angulo = Math.toRadians(grados);
            double x = (90 - imagen.getWidth())/2;
            double y = (90 - imagen.getHeight())/2;
            AffineTransform at = AffineTransform.getTranslateInstance(x,y);
            at.rotate(angulo, imagen.getWidth()/2, imagen.getHeight()/2);
            
            // Dibujamos la imagen original con la transformacin en la temporal
            g2.drawRenderedImage(imagen, at);
            
            // Liberamos la memoria usada
            g2.dispose();
            
            // Devolvemos la imagen rotada
            icono = new ImageIcon(bi);
        }

        return icono;
    }
    
    class ComplexCellRenderer implements ListCellRenderer {
    protected DefaultListCellRenderer defaultRenderer = new DefaultListCellRenderer();

    public Component getListCellRendererComponent(JList list, Object value, int index,
        boolean isSelected, boolean cellHasFocus) {

        JLabel renderer = (JLabel) defaultRenderer.getListCellRendererComponent(list, value, index,
            isSelected, cellHasFocus);
        
        renderer.setHorizontalAlignment(renderer.CENTER);
        renderer.setVerticalAlignment(renderer.CENTER);
        

        if ((value instanceof Propiedad) || (value instanceof Solar)) {
            //renderer.setIcon(new javax.swing.ImageIcon("res\\casilla" + ((Solar)value).getIdCasilla() + ".png"));
            
            int angulo;
            int numCasilla = ((Propiedad)value).getIdCasilla();
           
            if ((numCasilla > 1) && (numCasilla < 11)) angulo = 0;
            else if ((numCasilla > 11) && (numCasilla < 21)) angulo = -90;
            else if ((numCasilla > 21) && (numCasilla < 31)) angulo = 180;
            else angulo = 90;
            if ((numCasilla == 26) || (numCasilla == 29)) angulo = 0;
            
            renderer.setIcon(rotarImagen(((Propiedad)value).getIdCasilla(), angulo));
 
            renderer.setText("");
            renderer.setPreferredSize(new Dimension(90, 92));
            
        } 

        return renderer;
     }
    
    
    }
    
}
