package uhupoly;

import java.util.Random;


public class Comunidad extends Casilla {

    String texto;
    
    public Comunidad() {
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
    
        boolean terminar = true;
        boolean mover = true;
        
        Random rd = new Random();
        int numTarjeta = rd.nextInt(16);
            
        TarjetaComunidad tarjeta = juego.getTarjetasComunidad().get(numTarjeta);
        
        while (tarjeta.getPropietario() != null)
        {
        
            numTarjeta = rd.nextInt(16);
            tarjeta = juego.getTarjetasComunidad().get(numTarjeta);
            
        }
        
//        numTarjeta = 15;
            
        juego.getObservador().muestraInformacion("<html>Tarjeta de Comunidad:<br>" + tarjeta.getTexto());
        
        switch (numTarjeta) {
        
            case 0: {        //"Sitese en la Avenida de Andaluca."        
                int posicion = 2;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setPosicion(nuevaPosicion);
                
                // se hace la accion de la casilla nueva
                terminar = juego.getTablero().getCasillas().get(posicion).accion(jugadorActual, juego);
                mover = false;
                                       
            } break;
            
            case 1: {       //"Pague la factura del mdico: 30 "
                float factura = 30f;
                if (!arruinado(jugadorActual, juego, factura))
                    jugadorActual.setCapital(jugadorActual.getCapital() - factura);
                else
                    terminar = false;
            } break;
            
            case 2: {       //"Recibir su inters sobre el prestamo al 7%: 15 "
                float prestamo = 15f;
                jugadorActual.setCapital(jugadorActual.getCapital() + prestamo);            
            } break;
            
            case 3: {       //"En su aniversario reciba de cada jugador 6 ."
                int num = juego.getNumJugadores();
                float dinero = num * 6;
                jugadorActual.setCapital(jugadorActual.getCapital() + dinero);
                
                for (int i = 0; i < num; i++)
                    juego.getJugadores().get(i).setCapital(juego.getJugadores().get(i).getCapital() - 6f);
            
            } break;
            
            case 4: {       //"Pague al hospital: 60 ."
                float multa = 60f;
                if (!arruinado(jugadorActual, juego, multa))
                    jugadorActual.setCapital(jugadorActual.getCapital() - multa); 
                else
                    terminar = false;
            } break;
            
            case 5: {   //"Vaya directamente a la Crcel sin pasar por la casilla de salida."
                //directo a la carcel
                jugadorActual.setTurnosEnCarcel(3);
                jugadorActual.setDeVisita(false);
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(10);
                jugadorActual.setPosicion(nuevaPosicion);
                juego.getObservador().actualizaCasilla(nuevaPosicion);
                juego.getObservador().muestraTerminarTurno();
                terminar = true;                  
            } break;
            
            case 6: {     //"Pague una multa de 6 ."
                float multa = 6f;
                if (!arruinado(jugadorActual, juego, multa))
                    jugadorActual.setCapital(jugadorActual.getCapital() - multa);
                else
                    terminar = false;
            } break;
            
            case 7: {      //"Cobre una herencia de 60 ."
                float herencia = 60f;
                jugadorActual.setCapital(jugadorActual.getCapital() + herencia);            
            } break;
            
            case 8: {      //"Ha ganado el segundo premio de belleza: 6 ."
                float premio = 6f;
                jugadorActual.setCapital(jugadorActual.getCapital() + premio);
            } break;
            
            case 9: {      //"Pague su poliza de seguros: 30 "
                float poliza = 30f;
                if (!arruinado(jugadorActual, juego, poliza))
                    jugadorActual.setCapital(jugadorActual.getCapital() - poliza);
                else
                    terminar = false;
            } break;
            
            case 10: {     //"Contribuciones le devuelven 12 "
                float premio = 12f;
                jugadorActual.setCapital(jugadorActual.getCapital() + premio);                     
            } break;
            
            case 11: {     //"La venta de su stock le producen 30 "
                float venta = 30f;
                jugadorActual.setCapital(jugadorActual.getCapital() + venta);                    
            } break;
            
            case 12: {      //"Coloquese en la casilla de Salida."
                int posicion = 0;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
                jugadorActual.setPosicion(nuevaPosicion);
                juego.getObservador().actualizaCasilla(nuevaPosicion);
                mover = false;
            } break;
            
            case 13: {      //"Error de la banca a su favor. Reciba 238 "
                float error = 238f;
                jugadorActual.setCapital(jugadorActual.getCapital() + error); 
            } break;
            
            case 14: {      //"Queda libre de la carcel. Esta carta puede conservarse o venderse a otros jugadores."
                jugadorActual.getTarjetaJugador().add(tarjeta);
                tarjeta.setPropietario(jugadorActual);                            
                // ##################################### mostrarla en juego
            } break;
            
            case 15: {      //"Retroceda tres casillas."            
                int posicion = this.getIdCasilla()-1;
                
                int idxNuevaPosicion;
                if ((posicion - 3) < 0)
                    idxNuevaPosicion = 40 - (3 - posicion);
                else
                    idxNuevaPosicion = posicion - 3;

                juego.getObservador().actualizaCasilla(juego.getTablero().getCasillas().get(posicion));
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(idxNuevaPosicion);
                
                jugadorActual.setPosicion(nuevaPosicion);
                
                terminar = nuevaPosicion.accion(jugadorActual, juego);

                juego.getObservador().actualizaCasilla(nuevaPosicion);
                mover = false;
                
            } break;                    
        }
        
        if (terminar && mover)
            jugadorActual.setPosicion(this);

        return terminar;
    }
    
    public boolean arruinado(Jugador jugadorActual, Juego juego, float cantidad) {
    
    // comprobar si tiene suficiente en dinero. De no ser as,
                // mostrar aqu la obligacin de tener que hipotecar.
        boolean res = false;
        
                while (!jugadorActual.tieneEfectivo(cantidad))
                {

                    if (jugadorActual.estaArruinado(cantidad))
                    {
                        jugadorActual.entregarTodoA(null, juego);
                        juego.getObservador().muestraArruinado(jugadorActual);
                        juego.getObservador().muestraTerminarTurno();
                        return true;
                    }
                    else juego.getObservador().muestraSinDinero(jugadorActual, cantidad);
                }
        
        return res;
    }
}
