package uhupoly;

public class Estacion extends Propiedad {
    public Estacion() {
        
       setPrecio(238f);
       setValorHipoteca(120.2f);
        
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
        
        Casilla casillaAnterior = jugadorActual.getPosicion();
        
        jugadorActual.setPosicion(this);
        
        if (this.getPropietario() == null)
        {
            
            // actualiza las casillas en el tablero
            juego.getObservador().actualizaCasilla(casillaAnterior);
            juego.getObservador().actualizaCasilla(this);
            
            // muestra opcion de compra
            juego.getObservador().muestraOpcionCompra(this, jugadorActual, juego);
            
        } else
        {
            
            // resta alquiler y suma al propietario
            Jugador propietario = this.getPropietario();
            float alquiler = 15f;
            
            if (propietario != jugadorActual)
            {

                for (int i = 0; i < propietario.getPropiedades().size(); i++)
                    if (propietario.getPropiedades().get(i) instanceof Estacion)
                        alquiler = alquiler * 2;
                
                // comprobar si tiene capital suficiente en dinero. De ser as,
                // mostrar aqu la obligacin de tener que hipotecar.
                while (!jugadorActual.tieneEfectivo(alquiler))
                {
                    if (jugadorActual.estaArruinado(alquiler))
                    {
                        jugadorActual.entregarTodoA(propietario, juego);
                        juego.getObservador().muestraArruinado(jugadorActual);
                        juego.getObservador().muestraTerminarTurno();
                        return false;
                    }
                    else juego.getObservador().muestraSinDinero(jugadorActual, alquiler);
                }
                
                // restar al capital
                jugadorActual.setCapital(jugadorActual.getCapital() - alquiler);
            
                // notifica operacin   
                juego.getObservador().muestraInformacion("<html>Pagas un alquiler de <b>" + alquiler + "</b> a " + propietario.getNombre());
            }
            
        }
        
        return true;
    
    }
    
}
