package uhupoly;

import interfaz.*;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import javax.swing.JOptionPane;

public class Juego {
    private int numJugadores;

    private int turno;
    private int valorDado1;
    private int valorDado2;

    private ArrayList<TarjetaComunidad> tarjetasComunidad;

    private ArrayList<Dado> dados;

    private ArrayList<Jugador> jugadores;

    private Tablero tablero;

    private ArrayList<TarjetaSuerte> tarjetasSuerte;
    
    private ObservadorTablero observador;
    
    //------ Atributos para control del transcurso de la partida
    
    private int numVecesDobles;
    private Jugador jugadorActual;
    private Casilla casillaAnterior;
    
    //------

    public Juego() {
        // creamos los dados
        dados = new ArrayList(); 
        dados.add(new Dado());
        dados.add(new Dado());
        
        // creamos el tablero
        tablero = new Tablero();
        
        // creamos los jugadores
        jugadores = new ArrayList();
        
        // creamos las tarjetas de comunidad
        tarjetasComunidad = new ArrayList();
        tarjetasComunidad.add(new TarjetaComunidad("Sitese en la Avenida de Andaluca."));
        tarjetasComunidad.add(new TarjetaComunidad("Pague la factura del mdico: 30 "));
        tarjetasComunidad.add(new TarjetaComunidad("Recibir su inters sobre el prestamo al 7%: 15 "));
        tarjetasComunidad.add(new TarjetaComunidad("En su aniversario reciba de cada jugador 6 ."));
        tarjetasComunidad.add(new TarjetaComunidad("Pague al hospital: 60 ."));
        tarjetasComunidad.add(new TarjetaComunidad("Vaya directamente a la Crcel sin pasar por la casilla de salida."));
        tarjetasComunidad.add(new TarjetaComunidad("Pague una multa de 6 ."));
        tarjetasComunidad.add(new TarjetaComunidad("Cobre una herencia de 60 ."));
        tarjetasComunidad.add(new TarjetaComunidad("Ha ganado el segundo premio de belleza: 6 "));
        tarjetasComunidad.add(new TarjetaComunidad("Pague su poliza de seguros: 30 "));
        tarjetasComunidad.add(new TarjetaComunidad("Contribuciones le devuelven 12 "));
        tarjetasComunidad.add(new TarjetaComunidad("La venta de su stock le producen 30 "));
        tarjetasComunidad.add(new TarjetaComunidad("Coloquese en la casilla de Salida."));
        tarjetasComunidad.add(new TarjetaComunidad("Error de la banca a su favor. Reciba 238 "));
        tarjetasComunidad.add(new TarjetaComunidad("Queda libre de la carcel. Esta carta puede conservarse o venderse a otros jugadores."));
        tarjetasComunidad.add(new TarjetaComunidad("Retroceda tres casillas."));
        
        // creamos las tarjetas de suerte
        tarjetasSuerte = new ArrayList();
        tarjetasSuerte.add(new TarjetaSuerte("Vaya a la calle de Bilbao. Si pasa por la casilla de SALIDA, cobre 238 "));
        tarjetasSuerte.add(new TarjetaSuerte("La inspeccin de la calle le obliga a reparaciones. Pague: 24  por casa y 66  por hotel."));
        tarjetasSuerte.add(new TarjetaSuerte("Pague por gastos escolares 90 ."));
        tarjetasSuerte.add(new TarjetaSuerte("Vaya a la estacin de Autobuses. Si pasa por la casilla de SALIDA, cobre 238 ."));
        tarjetasSuerte.add(new TarjetaSuerte("Adelante hasta la casilla de SALIDA."));
        tarjetasSuerte.add(new TarjetaSuerte("Multa por embriaguez: 12 "));
        tarjetasSuerte.add(new TarjetaSuerte("Vaya a la calle de Coln. Si pasa por la casilla de SALIDA, cobre 238 ."));
        tarjetasSuerte.add(new TarjetaSuerte("Vaya a G.V. Fernando el Catlico. Si pasa por la casilla de SALIDA, cobre 238 ."));
        tarjetasSuerte.add(new TarjetaSuerte("Multa por exceso de velocidad: 9 ."));
        tarjetasSuerte.add(new TarjetaSuerte("La Banca arroja un dividendo de 30 ."));
        tarjetasSuerte.add(new TarjetaSuerte("Vaya directamente a la Crcel sin pasar por la casilla de salida."));
        tarjetasSuerte.add(new TarjetaSuerte("Su inmueble y su prstamo producen 90 ."));
        tarjetasSuerte.add(new TarjetaSuerte("Retroceda tres casillas."));
        tarjetasSuerte.add(new TarjetaSuerte("Ha ganado el premio de palabras cruzadas: 60 "));
        tarjetasSuerte.add(new TarjetaSuerte("Queda libre de la carcel. Esta carta puede conservarse o venderse a otros jugadores."));
        tarjetasSuerte.add(new TarjetaSuerte("Haga reparaciones en todas sus casas. Pague por cada casa 15  y por cada hotel 60 ."));

        setTurno(0);
        
     
        
    }

    public ArrayList<TarjetaComunidad> getTarjetasComunidad() {
        return tarjetasComunidad;
    }

    public void setTarjetasComunidad(ArrayList<TarjetaComunidad> val) {
        this.tarjetasComunidad = val;
    }

    public ArrayList<Dado> getDados() {
        return dados;
    }

    public void setDados(ArrayList<Dado> val) {
        this.dados = val;
    }

    public ArrayList<Jugador> getJugadores() {
        return jugadores;
    }

    public void setJugadores(ArrayList<Jugador> val) {
        this.jugadores = val;
    }

    public Tablero getTablero() {
        return tablero;
    }

    public void setTablero(Tablero val) {
        this.tablero = val;
    }

    public ArrayList<TarjetaSuerte> getTarjetasSuerte() {
        return tarjetasSuerte;
    }

    public void setTarjetasSuerte(ArrayList<TarjetaSuerte> val) {
        this.tarjetasSuerte = val;
    }

    public int getNumJugadores() {
        return numJugadores;
    }

    public void setNumJugadores(int val) {
        this.numJugadores = val;
    }
    
    public int getValorDado1() {
        return valorDado1;
    }

    public void setValorDado1(int val) {
        this.valorDado1 = val;
    }
    
    public int getValorDado2() {
        return valorDado2;
    }

    public void setValorDado2(int val) {
        this.valorDado2 = val;
    }
    
    public ObservadorTablero getObservador() {
        return observador;
    }

    public void setObservador(ObservadorTablero val) {
        this.observador = val;
    }

    public void tirarDados() {
        dados.get(0).lanzarDado();
        valorDado1 = dados.get(0).getValorCara();
        dados.get(1).lanzarDado();
        valorDado2 = dados.get(1).getValorCara();
        
        observador.muestraTirada(valorDado1, valorDado2);
    }

    public int getTurno() {
        return turno;
    }

    public void setTurno(int val) {
        this.turno = val;
    }
    
    /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     */
    
    public void comenzarJuego() {
        turno = 0;
        numVecesDobles = 0;
        jugadorActual = jugadores.get(getTurno());
        observador.muestraTurnoLanzar(jugadores.get(turno).getNombre());
        observador.mostrarLogotipo(true);
        
    }
    
    public void cambiarTurno() {
        
        Jugador jugadorAnterior = jugadorActual;
        int numArruinados = 0;
        
        do {
            turno = (turno + 1) % numJugadores;
            numVecesDobles = 0;
            jugadorActual = jugadores.get(getTurno());
        } while (jugadorActual.getArruinado());
        
        for (int i = 0; i < numJugadores; i++)
            if (jugadores.get(i).getArruinado())
                numArruinados++;
        
        if (numJugadores ==  (numArruinados+1))
        {
            // Mostrar fin del juego con el ganador jugadorActual.
            observador.muestraFinDelJuego(this, jugadorActual);
            return;
        }
        
        if ((jugadorActual.getPosicion().getIdCasilla() == 11) && (jugadorActual.getDeVisita() == false))
            observador.muestraMensajeSecundario("Recuerda que ests en la crcel!");
        
        observador.muestraTurnoLanzar(jugadores.get(turno).getNombre());
    }
    
    public void jugar() {
    
        boolean dobles;
        Casilla casillaActual;
        Casilla casillaDestino;
        
        
        // ver si esta en la carcel para poder usar las tarjetas de salida
        if ((jugadorActual.getPosicion().getIdCasilla() == 11) && (jugadorActual.getDeVisita() == false) &&
                (jugadorActual.getTarjetaJugador().size() > 0))
        {
            
            if (JOptionPane.showConfirmDialog(null, "TE ENCUENTRAS EN LA CARCEL.\nTienes la tarjeta para salir gratis de la crcel.\nQuieres usarla?",
                                    "Salir de la crcel", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION)
            {
                
                Tarjeta tarjeta = jugadorActual.getTarjetaJugador().get(0);
                jugadorActual.getTarjetaJugador().remove(tarjeta);
                tarjeta.setPropietario(null);
                
                jugadorActual.setTurnosEnCarcel(0);
                jugadorActual.setDeVisita(true);
                    //muestra que queda libre por dobles
                observador.muestraInformacion("Quedas libre de la crcel por usar tarjeta!!!");
                    //muestra tirar dados
                observador.muestraTurnoLanzar(jugadorActual.getNombre());
                return;
            
            }
            
        }
 
        
        tirarDados();

//        valorDado1 = 1;
//        valorDado2 = 1;
        
        dobles = (valorDado1 == valorDado2);
        //***** notifica tirada
        observador.muestraTirada(valorDado1, valorDado2);
        
        // si esta en la carcel
        if ((jugadorActual.getPosicion().getIdCasilla() == 11) && (jugadorActual.getDeVisita() == false))
        {
        
            observador.muestraMensajeSecundario("Recuerda que ests en la crcel!");
            
            
            if (jugadorActual.getTurnosEnCarcel() > 1) // le quedan ms de un turno
            {
                
                if (dobles)
                {
			//se saca de la carcel
                    jugadorActual.setTurnosEnCarcel(0);
                    jugadorActual.setDeVisita(true);
			//muestra que queda libre por dobles
                    observador.muestraInformacion("Quedas libre de la crcel por sacar dobles!!!");
			//muestra tirar dados
                    observador.muestraTurnoLanzar(jugadorActual.getNombre());
                    return;
                } else
                {
                    
                    boolean quierePagar = false;
                    
                    if (jugadorActual.tieneEfectivo(60f))
                        quierePagar = (JOptionPane.showConfirmDialog(null, "Deseas pagar 60 y salir directamente de la crcel?",
                                    "Salir de la crcel", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION);
                    
                    if (quierePagar)
                    {
			//se saca de la carcel
                        jugadorActual.setTurnosEnCarcel(0);
                        jugadorActual.setDeVisita(true);
                        
                        
                        // se le cobran los 60
                        jugadorActual.setCapital(jugadorActual.getCapital() - 60f);
                        
			//muestra que queda libre
                        observador.muestraInformacion("Quedas libre de la crcel por pagar fianza");
			//muestra tirar dados
                        observador.muestraTurnoLanzar(jugadorActual.getNombre());
                        return;
                    } else
                    {
                        //decrementa turnos en la carcel
                        jugadorActual.setTurnosEnCarcel(jugadorActual.getTurnosEnCarcel()-1);
			//activa TERMINAR____________
                        observador.muestraTerminarTurno();
                        return;
                    }
                }
                
            } else // ste es el ltimo turno que est
            {
                    
                if (dobles)
                {
                    //muestra que queda libre por dobles
                    observador.muestraInformacion("Quedas libre de la crcel por sacar dobles!!!</b><br>Vuelves a tirar otra vez</html>");
                    jugadorActual.setTurnosEnCarcel(0);
                    jugadorActual.setDeVisita(true);
                    observador.muestraTurnoLanzar(jugadorActual.getNombre());
                    return;
                } else
                {
                    //pagua 10.000
                    // comprobar si tiene suficiente en dinero. De no ser as,
                    // mostrar aqu la obligacin de tener que hipotecar.
                    while (!jugadorActual.tieneEfectivo(60f))
                    {

                        if (jugadorActual.estaArruinado(60f))
                        {
                            jugadorActual.entregarTodoA(null, this);
                            observador.muestraArruinado(jugadorActual);
                            observador.muestraTerminarTurno();
                            return;
                        }
                        else observador.muestraSinDinero(jugadorActual, 60f);
                    }
                
                    jugadorActual.setCapital(jugadorActual.getCapital() - 60f);
                    //muestra que queda libre por pagar
                    observador.muestraInformacion("<b>Quedas libre de la crcel y pagas al salir</b>");
                }
                //se saca de la carcel
                jugadorActual.setTurnosEnCarcel(0);
                jugadorActual.setDeVisita(true);
                //muestra tirar dados
                observador.muestraTurnoLanzar(jugadorActual.getNombre());
            }
            
            
        } // fin de si est en la crcel
        
        if (dobles)
            numVecesDobles += 1;
        
        if (numVecesDobles == 3)
        {
            //directo a la carcel
            jugadorActual.setTurnosEnCarcel(3);
            jugadorActual.setDeVisita(false);
            casillaActual = jugadorActual.getPosicion();
            jugadorActual.setPosicion(tablero.getCasillas().get(10));
            //muestra que son 3 dobles y va a la carcel
            observador.muestraMensaje("<b>Vas a la crcel por sacar 3 veces dobles!!!</b>");
            
            observador.actualizaCasilla(casillaActual);
            observador.actualizaCasilla(tablero.getCasillas().get(10));
            
            //activa TERMINAR_____________
            observador.muestraTerminarTurno();
            return;
        }
        
        //muestra resultado de tirada en pantalla, se hace lo que haya.
        casillaActual = jugadorActual.getPosicion();
        casillaDestino = tablero.getCasillas().get((casillaActual.getIdCasilla()-1 + valorDado1 + valorDado2) % 40);
        
        // Si pasa por la casilla de salida, cobrar dinero
        if (casillaDestino.getIdCasilla() < casillaActual.getIdCasilla())
        {
            jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
            observador.actualizaJugador(jugadorActual);
        }
        
        // se hace lo que haya en esa casilla
        boolean seguirTurno = casillaDestino.accion(jugadorActual, this);
        
        // actualizar en la interfaz grfica
        observador.actualizaJugador(jugadorActual);
        observador.actualizaCasilla(casillaActual);
        observador.actualizaCasilla(casillaDestino);
        
        // Si por la accin no debe seguir con su turno, terminarlo.
        if (!seguirTurno) return;
        
	//activa opciones
        observador.activaOpciones();
        
        //si no saco dobles, activa TERMINAR
        if (!dobles)
        {
        
            observador.muestraTerminarTurno();
            
        } else //si saco dobles:
        {
        
            //turno al mismo, muestra quien tiene el turno (por dobles), muestra tirar dados
            observador.muestraTurnoLanzar(jugadores.get(turno).getNombre());
        
        }
        
    
    }

    public void resetJuego() {
    
        Solar solar;

        jugadores.clear();
        for (int i = 0; i < 40; i++)
        {
            if (tablero.getCasillas().get(i) instanceof Solar)
            {
                solar = ((Solar)tablero.getCasillas().get(i));
                solar.setPropietario(null);
                solar.setNumCasas(0);
                solar.setTieneHotel(false);
            }
            if (tablero.getCasillas().get(i) instanceof Estacion)
                ((Estacion)tablero.getCasillas().get(i)).setPropietario(null);
            if (tablero.getCasillas().get(i) instanceof ServicioPublico)
                ((ServicioPublico)tablero.getCasillas().get(i)).setPropietario(null);
        }
        
        
        tarjetasComunidad.get(14).setPropietario(null);
        tarjetasSuerte.get(14).setPropietario(null);    
    
    }

}
