package uhupoly;

import java.util.ArrayList;

public class Jugador {
    private String nombre;

    private float capital;

    private boolean deVisita;

    private int turnosEnCarcel;

    private Casilla posicion;

    private ArrayList<Tarjeta> tarjetaJugador;

    private ArrayList<Propiedad> propiedades;
    
    private int numJugador;
    
    private boolean arruinado;

    public Jugador(String nom) {
        
        nombre = nom;
        capital = 1800f;
        deVisita = true;
        turnosEnCarcel = 0;
        posicion = null;
        tarjetaJugador = null;
        propiedades = new ArrayList();
        tarjetaJugador =  new ArrayList();
        arruinado = false;
        
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String val) {
        this.nombre = val;
    }

    public float getCapital() {
        return capital;
    }

    public void setCapital(float val) {
        this.capital = val;
    }

    public boolean getDeVisita() {
        return deVisita;
    }

    public void setDeVisita(boolean val) {
        this.deVisita = val;
    }

    public int getTurnosEnCarcel() {
        return turnosEnCarcel;
    }

    public void setTurnosEnCarcel(int val) {
        this.turnosEnCarcel = val;
    }

    public Casilla getPosicion() {
        return posicion;
    }

    public void setPosicion(Casilla val) {
        this.posicion = val;
    }

    public ArrayList<Tarjeta> getTarjetaJugador() {
        return tarjetaJugador;
    }

    public void setTarjetaJugador(ArrayList<Tarjeta> val) {
        this.tarjetaJugador = val;
    }

    public ArrayList<Propiedad> getPropiedades() {
        return propiedades;
    }

    public void setPropiedades(ArrayList<Propiedad> val) {
        this.propiedades = val;
    }
    
    public boolean getArruinado() {
        return arruinado;
    }

    public void setArruinado(boolean val) {
        this.arruinado = val;
    }
    
    public boolean tieneEfectivo(float cantidad) {
        return (cantidad <= capital);
    }
    
    public boolean estaArruinado(float cantidadDebida) {
        boolean res = false;
        
        float sumaBienes = 0;
        Propiedad propiedad;
        Solar solar;
        
        for (int i = 0; i < propiedades.size(); i++)
        {
            propiedad = propiedades.get(i);
            if (!propiedad.getHipotecada())
            {
            
                if (propiedad instanceof Solar)
                {
                    if (((Solar)propiedad).getTieneHotel())
                        sumaBienes += ((Solar)propiedad).getPrecioHotel() / 2;
                    else
                        sumaBienes += ((Solar)propiedad).getNumCasas() * ((Solar)propiedad).getPrecioCasa() / 2;
                }

                sumaBienes += propiedad.getValorHipoteca();

            }
        }
        
        sumaBienes += capital;
        
        res = (sumaBienes < cantidadDebida);
        
        return res;
    }
    
    public void entregarTodoA(Jugador jugador, Juego juego) {
    
        arruinado = true;
        
        if (jugador != null)
        {
        
            float capitalConstrucciones = 0;
            Solar solar;
            for (int i = 0; i < propiedades.size(); i++)
                if (propiedades.get(i) instanceof Solar)
                {
                    solar = ((Solar)propiedades.get(i));
                    if (solar.getTieneHotel())
                        capitalConstrucciones += solar.getPrecioHotel() / 2;
                    else
                        capitalConstrucciones += solar.getPrecioCasa() * solar.getNumCasas() / 2;
                } 

            Propiedad propiedad;
            float interesesHipoteca = 0;
            for (int i = 0; i < propiedades.size(); i++)
            {
                propiedad = propiedades.get(i);
                propiedad.setPropietario(jugador);
                jugador.getPropiedades().add(propiedad);
                juego.getObservador().actualizaCasilla(propiedad);
                if (propiedad.getHipotecada())
                    interesesHipoteca += propiedad.getValorHipoteca() * 0.1f;
            }

            jugador.setCapital(jugador.getCapital() + capitalConstrucciones + this.capital - interesesHipoteca);
            juego.getObservador().actualizaJugador(jugador);
        }
        else
        {
            for (int i = 0; i < propiedades.size(); i++)
            {
                juego.getObservador().muestraOpcionSubasta(propiedades.get(i), juego);
            }
        }
    }
    
    public int getNumJugador() {
        return numJugador;
    }

    public void setNumJugador(int val) {
        this.numJugador = val;
    }
}
