package uhupoly;

import interfaz.GuiCompraPropiedad;
import java.util.ArrayList;

public class Solar extends Propiedad {
    private float precioCasa;

    private int numCasas;

    private boolean tieneHotel;

    private float precioHotel;

    private float[] alquileres;

    private ArrayList<Solar> asociados;

    public Solar(float precio, float valHipoteca, float preCasa, float preHotel, float alq,
            float alq1casa, float alq2casa, float alq3casa, float alq4casa, float alqHotel) {
        
        super();
        
        asociados = new ArrayList();
        setPrecio(precio);
        setValorHipoteca(valHipoteca);
        precioCasa = preCasa;
        precioHotel = preHotel;
        alquileres = new float[6];
        alquileres[0] = alq;
        alquileres[1] = alq1casa;
        alquileres[2] = alq2casa;
        alquileres[3] = alq3casa;
        alquileres[4] = alq4casa;
        alquileres[5] = alqHotel;
        
        numCasas = 0;
        tieneHotel = false;
        
    }

    public float getPrecioCasa() {
        return precioCasa;
    }

    public void setPrecioCasa(float val) {
        this.precioCasa = val;
    }

    public int getNumCasas() {
        return numCasas;
    }

    public void setNumCasas(int val) {
        this.numCasas = val;
    }

    public ArrayList<Solar> getAsociados() {
        return asociados;
    }

    public void setAsociados(ArrayList<Solar> val) {
        this.asociados = val;
    }

    public boolean getTieneHotel() {
        return tieneHotel;
    }

    public void setTieneHotel(boolean val) {
        this.tieneHotel = val;
    }

    public float getPrecioHotel() {
        return precioHotel;
    }

    public void setPrecioHotel(float val) {
        this.precioHotel = val;
    }

    public float[] getAlquileres() {
        return alquileres;
    }

    public void setAlquileres(float[] val) {
        this.alquileres = val;
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
    
        Casilla casillaAnterior = jugadorActual.getPosicion();
        
        jugadorActual.setPosicion(this);
        juego.getObservador().actualizaCasilla(this);
        
        if (this.getPropietario() == null)
        {
            // actualiza las casillas en el tablero
            juego.getObservador().actualizaCasilla(casillaAnterior);
            juego.getObservador().actualizaCasilla(this);
            
            // muestra opcion de compra
            juego.getObservador().muestraOpcionCompra(this, jugadorActual, juego);
                
        } else
        {
            
            // resta alquiler y suma al propietario
            Jugador propietario = this.getPropietario();
            float alquiler = 0;
            
            // Realizar alquiler slo si el jugador no es el dueo
            if (jugadorActual != propietario)
            {
                
                if (this.getTieneHotel())
                    alquiler = this.getAlquileres()[5];
                else
                    alquiler = this.getAlquileres()[this.getNumCasas()];
                
                // comprobar si tiene suficiente en dinero. De no ser as,
                // mostrar aqu la obligacin de tener que hipotecar.
                while (!jugadorActual.tieneEfectivo(alquiler))
                {

                    if (jugadorActual.estaArruinado(alquiler))
                    {
                        jugadorActual.entregarTodoA(propietario, juego);
                        juego.getObservador().muestraArruinado(jugadorActual);
                        juego.getObservador().muestraTerminarTurno();
                        return false;
                    }
                    else juego.getObservador().muestraSinDinero(jugadorActual, alquiler);
                }
               
                // hacer traspaso de capital
                jugadorActual.setCapital(jugadorActual.getCapital() - alquiler);
                propietario.setCapital(propietario.getCapital() + alquiler);
               
                juego.getObservador().actualizaJugador(propietario);

                // notifica operacin
            juego.getObservador().muestraInformacion("<html>Pagas un alquiler de <b>" + alquiler + "</b> a " + propietario.getNombre());
            }
                
        }
        
        return true;
    }
}
