package uhupoly;

import java.util.Random;


public class Suerte extends Casilla {
    public Suerte() {
    }
    
   public boolean accion(Jugador jugadorActual, Juego juego) {
    
       boolean terminar = true;
       boolean mover = true;
        
        Random rd = new Random();
        int numTarjeta = rd.nextInt(16);
            
        TarjetaSuerte tarjeta = juego.getTarjetasSuerte().get(numTarjeta);
        
        while (tarjeta.getPropietario() != null)
        {
        
            numTarjeta = rd.nextInt(16);
            tarjeta = juego.getTarjetasSuerte().get(numTarjeta);
            
        }
            
        juego.getObservador().muestraInformacion("<html>Tarjeta de Suerte:<br>" + tarjeta.getTexto());
        
//        numTarjeta = 12;
        
        switch (numTarjeta) {
        
            case 0: {        //"Vaya a la calle de Bilbao. Si pasa por la casilla de SALIDA, cobre 238 "        
                int posicion = 11;
                int posicionActual = jugadorActual.getPosicion().getIdCasilla()-1;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setPosicion(nuevaPosicion);
                
                // Si pasa por la salida, cobra
                if (posicionActual > posicion)
                    jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
                
                // se hace la accion de la casilla nueva
                terminar = juego.getTablero().getCasillas().get(posicion).accion(jugadorActual, juego);
                mover = false;
                
            } break;
            
            case 1: {       //"La inspeccin de la calle le obliga a reparaciones. Pague: 24  por casa y 66  por hotel."
                float precio = 0;
                Solar solar;
                for (int i = 0; i < jugadorActual.getPropiedades().size(); i++)
                {
                    if (jugadorActual.getPropiedades().get(i) instanceof Solar)
                    {
                        solar = ((Solar)jugadorActual.getPropiedades().get(i));
                        if (solar.getTieneHotel())
                            precio += 66f;
                        else
                            precio += 24f * solar.getNumCasas();
                    }
                }
                
                if (!arruinado(jugadorActual, juego, precio))
                    jugadorActual.setCapital(jugadorActual.getCapital() - precio); 
                else
                    terminar = false;
                
            } break;
            
            case 2: {       //"Pague por gastos escolares 90 ."
                float gastos = 90;
                if (!arruinado(jugadorActual, juego, gastos))
                    jugadorActual.setCapital(jugadorActual.getCapital() - gastos); 
                else
                    terminar = false;
            } break;
            
            case 3: {       //"Vaya a la estacin de Autobuses. Si pasa por la casilla de SALIDA, cobre 238 ."
                int posicion = 15;
                int posicionActual = jugadorActual.getPosicion().getIdCasilla()-1;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setPosicion(nuevaPosicion);
                
                // Si pasa por la salida, cobra
                if (posicionActual > posicion)
                    jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
                
                // se hace la accion de la casilla nueva
                terminar = juego.getTablero().getCasillas().get(posicion).accion(jugadorActual, juego);
                mover = false;
                
            } break;
            
            case 4: {       //"Adelante hasta la casilla de SALIDA."
                int posicion = 0;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
                jugadorActual.setPosicion(nuevaPosicion);
                juego.getObservador().actualizaCasilla(nuevaPosicion);    
                mover = false;
            } break;
            
            case 5: {   //"Multa por embriaguez: 12 "
                float multa = 12f;
                if (!arruinado(jugadorActual, juego, multa))
                    jugadorActual.setCapital(jugadorActual.getCapital() - multa); 
                else
                    terminar = false;               
            } break;
            
            case 6: {     //"Vaya a la calle de Coln. Si pasa por la casilla de SALIDA, cobre 238 ."
                int posicion = 24;
                int posicionActual = jugadorActual.getPosicion().getIdCasilla()-1;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setPosicion(nuevaPosicion);
                
                // Si pasa por la salida, cobra
                if (posicionActual > posicion)
                    jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
                
                // se hace la accion de la casilla nueva
                terminar = juego.getTablero().getCasillas().get(posicion).accion(jugadorActual, juego);         
                mover = false;
                
            } break;
            
            case 7: {      //"Vaya a G.V. Fernando el Catlico. Si pasa por la casilla de SALIDA, cobre 238 ."
                int posicion = 39;
                int posicionActual = jugadorActual.getPosicion().getIdCasilla()-1;
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(posicion);
                jugadorActual.setPosicion(nuevaPosicion);
                
                // Si pasa por la salida, cobra
                if (posicionActual > posicion)
                    jugadorActual.setCapital(jugadorActual.getCapital() + 238f);
                
                // se hace la accion de la casilla nueva
                terminar = juego.getTablero().getCasillas().get(posicion).accion(jugadorActual, juego);   
                mover = false;
                
            } break;
            
            case 8: {      //"Multa por exceso de velocidad: 9 ."
                float multa = 9f;
                if (!arruinado(jugadorActual, juego, multa))
                    jugadorActual.setCapital(jugadorActual.getCapital() - multa); 
                else
                    terminar = false;
            } break;
            
            case 9: {      //"La Banca arroja un dividendo de 30 ."
                float dividendo = 30f;
                jugadorActual.setCapital(jugadorActual.getCapital() + dividendo);
            } break;
            
            case 10: {     //"Vaya directamente a la Crcel sin pasar por la casilla de salida."
                //directo a la carcel
                jugadorActual.setTurnosEnCarcel(3);
                jugadorActual.setDeVisita(false);
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(10);
                jugadorActual.setPosicion(nuevaPosicion);
                juego.getObservador().actualizaCasilla(nuevaPosicion);
                juego.getObservador().muestraTerminarTurno();
                terminar = true;                      
            } break;
            
            case 11: {     //"Su inmueble y su prstamo producen 90 ."
                float inmueble = 90f;  
                jugadorActual.setCapital(jugadorActual.getCapital() + inmueble);                    
            } break;
            
            case 12: {      //"Retroceda tres casillas."
                int posicion = this.getIdCasilla()-1;

                int idxNuevaPosicion;
                if ((posicion - 3) < 0)
                    idxNuevaPosicion = 39 - (3 - posicion);
                else
                    idxNuevaPosicion = posicion - 3;
         
                Casilla nuevaPosicion = juego.getTablero().getCasillas().get(idxNuevaPosicion);
                
                juego.getObservador().actualizaCasilla(juego.getTablero().getCasillas().get(posicion));
                
                jugadorActual.setPosicion(nuevaPosicion);

                juego.getObservador().actualizaCasilla(nuevaPosicion);

                terminar = nuevaPosicion.accion(jugadorActual, juego);   
                mover = false;
                
            } break;
            
            case 13: {      //"Ha ganado el premio de palabras cruzadas: 60 "
                float premio = 60f;
                jugadorActual.setCapital(jugadorActual.getCapital() + premio);
            } break;
            
            case 14: {      //"Queda libre de la carcel. Esta carta puede conservarse o venderse a otros jugadores."
                jugadorActual.getTarjetaJugador().add(tarjeta);
                tarjeta.setPropietario(jugadorActual);                            
                // ##################################### mostrarla en juego                           
            } break;
            
            case 15: {      //"Haga reparaciones en todas sus casas. Pague por cada casa 15  y por cada hotel 60 ."
                float precio = 0;
                Solar solar;
                for (int i = 0; i < jugadorActual.getPropiedades().size(); i++)
                {
                    if (jugadorActual.getPropiedades().get(i) instanceof Solar)
                    {
                        solar = ((Solar)jugadorActual.getPropiedades().get(i));
                        if (solar.getTieneHotel())
                            precio += 60f;
                        else
                            precio += 15f * solar.getNumCasas();
                    }
                }
                
                if (!arruinado(jugadorActual, juego, precio))
                    jugadorActual.setCapital(jugadorActual.getCapital() - precio); 
                else
                    terminar = false;       
            } break;
            
        }
        
        if (terminar && mover)
            jugadorActual.setPosicion(this);

        return terminar;
    }
    
    public boolean arruinado(Jugador jugadorActual, Juego juego, float cantidad) {
    
    // comprobar si tiene suficiente en dinero. De no ser as,
                // mostrar aqu la obligacin de tener que hipotecar.
        boolean res = false;
        
                while (!jugadorActual.tieneEfectivo(cantidad))
                {

                    if (jugadorActual.estaArruinado(cantidad))
                    {
                        jugadorActual.entregarTodoA(null, juego);
                        juego.getObservador().muestraArruinado(jugadorActual);
                        juego.getObservador().muestraTerminarTurno();
                        return true;
                    }
                    else juego.getObservador().muestraSinDinero(jugadorActual, cantidad);
                }
        
        return res;
    
    }
}
